unit Modify;

interface

uses
{$IFDEF WIN32}
  Windows, ComCtrls,
{$ELSE}
  WinTypes, WinProcs,
{$ENDIF}
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Segment, StdCtrls, Buttons, Menus;

type
  TModForm = class(TForm)
    GroupBox1: TGroupBox;
    LB: TListBox;
    CloseBtn: TBitBtn;
    LBMenu: TPopupMenu;
    PMDel: TMenuItem;
    PMView: TMenuItem;
    PMTarget: TMenuItem;
    TheCnt: TLabel;
    procedure CloseBtnClick(Sender: TObject);
    procedure PMDelClick(Sender: TObject);
    procedure PMViewClick(Sender: TObject);
    procedure PMTargetClick(Sender: TObject);
    procedure LBMenuPopup(Sender: TObject);
  private
    { Private declarations }
    procedure TheCount;
  public
    { Public declarations }
    procedure EntryPoint;
  end;

var
  ModForm: TModForm;

implementation

uses Main, SegArc, Common;

{$R *.DFM}

{===============================================================}
{===============================================================}
procedure TModForm.TheCount;
begin
     TheCnt.Caption := 'Count: ' + IntToStr(LB.Items.Count);
end;

{===============================================================}
{===============================================================}
procedure TModForm.EntryPoint;
var
  SArc:     TSegArc;
  i:        Integer;
begin
     LB.Clear;
     for i := 0 to MainForm.SegCompEZ.SegArcList.Count-1 do
       begin
       SArc := MainForm.SegCompEZ.GetSegArc(i);
       LB.Items.Add(SArc.Template);
       end;
     LB.ItemIndex := -1;
     TheCount;
     ShowModal;
end;

{===============================================================}
{===============================================================}
procedure TModForm.CloseBtnClick(Sender: TObject);
begin
     Close;
end;

{===============================================================}
{===============================================================}
procedure TModForm.LBMenuPopup(Sender: TObject);
var
   State:     Boolean;
begin
     with LBMenu do
       begin
       State := False;
       if ((LB.Items.Count > 0) and (LB.ItemIndex >= 0)) then
         State := True;
       PMDel.Enabled := State;
       PMView.Enabled := State;
       PMTarget.Enabled := State;
       end;
end;

{===============================================================}
{===============================================================}
procedure TModForm.PMDelClick(Sender: TObject);
var
  i:         Integer;
  SArc:      TSegArc;
begin
     while (LB.ItemIndex >= 0) do
       begin
       for i := 0 to LB.Items.Count-1 do
         begin
         if (LB.Selected[i]) then
           begin
           LB.Items.Delete(i);
           with MainForm.SegCompEZ do
             begin
             SArc := GetSegArc(i);
             SegArcList.Remove(SArc);
             SArc.Free;
             end;
           break;
           end;
         end;
       end;

     TheCount;
end;

{===============================================================}
{===============================================================}
procedure TModForm.PMViewClick(Sender: TObject);
var
   SArc:     TSegArc;
begin
     if (LB.ItemIndex >= 0) then
       begin
       SArc := MainForm.SegCompEZ.GetSegArc(LB.ItemIndex);
       SegArcForm.EntryPoint(SArc);
       if (SArc.SL.Count = 0) then
         begin
         MainForm.SegCompEZ.SegArcList.Remove(SArc);
         SArc.Free;
         LB.Items.Delete(LB.ItemIndex);
         TheCount;
         end;
       end;
end;

{===============================================================}
{===============================================================}
procedure TModForm.PMTargetClick(Sender: TObject);
var
  NewTarget:       String;
  SaveTemp:        String;
  SArc:            TSegArc;
begin
     if (LB.ItemIndex >= 0) then
       begin
       SArc := MainForm.SegCompEZ.GetSegArc(LB.ItemIndex);
       SaveTemp := ExtractFileName(LB.Items[LB.ItemIndex]);
       NewTarget := SArc.Target;
       NewTarget := InputBox('Change Target','New Target',NewTarget);
       if (NewTarget <> '') then
         begin
         SArc.Target := MakeTarget(NewTarget);
         LB.Items[LB.ItemIndex] := SArc.Target + SaveTemp;
         end;
       end;
end;

end.
